/*var gNext = document.getElementById("btnRight");
var gPrev = document.getElementById("btnLeft");
var gDesc = document.getElementById("galleryDesc");
var gPrecio = document.getElementById("galleryPrecio");
var gImagen = document.getElementById("galleryImagen");
var gComprar = document.getElementById("galleryComprar");

var opciones = basicGalleryOptions;
var indice = 0;




gPrecio.style["color"] = opciones.ColorPrecio;
gDesc.style["color"] = opciones.ColorProducto;

function gNextImg() {
    if (indice < opciones.data.length - 1) {
        indice++;
        showGallery(indice);

    }
    console.log(indice);
}
function gPrevImg() {
    if (indice > 0) {
        indice--;
        showGallery(indice);
    }
    console.log(indice);
}

var r = Math.floor((Math.random() * (opciones.data.length)));
function showGallery(i) {
    indice = i;
    console.log(indice);
    gImagen.src = opciones.data[i].url;
    gDesc.innerHTML = opciones.data[i].titulo;
    gPrecio.innerHTML = opciones.data[i].precio;
}
showGallery(r);

gNext.onclick = function () {
    gNextImg();
};
gPrev.onclick = function () {
    gPrevImg();
};
gComprar.onclick = function () {
    comprar();
};*/

//----------------------------------------------------------------------------------------------------------------

function eplProductGallery(_container, _opt, _isMobile){
    this.container = document.getElementById(_container);
    this.options = _opt;
    this.isMobile = _isMobile;
    console.log("gallery mobile:" + this.isMobile);
    this.cols = (this.isMobile === true)?1:3;
    this.nextButton = null;
    this.prevButton = null;
    this.productos = this.options.data;
    this.randomProducto = Math.floor((Math.random() * (this.productos.length)));
    this.indiceProducto = this.randomProducto;
}

eplProductGallery.prototype.createBox = function(_w, _h, _centerV, _centerH){
    var d = document.createElement("div");
    d.style["display"] = "flex";
    d.style["width"] = _w;
    d.style["height"] = _h;
    d.style["align-items"] = _centerH;
    d.style["justify-content"] = _centerV;
    return d;
};

eplProductGallery.prototype.getNextIndice = function(){
    if(this.indiceProducto == this.productos.length - 1){
        this.indiceProducto = 0;
    }else{
        this.indiceProducto++;
    }
    return this.indiceProducto;
};

eplProductGallery.prototype.getPrevIndice = function(){
    if(this.indiceProducto == 0){
        this.indiceProducto = this.productos.length - 1;
    }else{
        this.indiceProducto--;
    }
    return this.indiceProducto;
};

eplProductGallery.prototype.createPrevButton = function(){
    var that = this;
    var container = this.createBox("10%", "100%", "center", "center");
    var btn = this.createBox("100%", "20%", "center", "center");
    btn.style["cursor"] = "pointer";
    btn.style["border"] = "1px solid gray";
    btn.style["font-size"] = "3vw";
    btn.innerHTML = "<";
    btn.onclick = function(){that.prevProduct();};
    container.appendChild(btn);
    this.container.appendChild(container);
};

eplProductGallery.prototype.comprarProducto = function(producto, ct, ca){
    var that = this;
    parent.postMessage("customAction_" + ct + "_" + ca, "*");
    console.log("Comprar Producto: " + producto + "/ ClickTag: " + ct + " / CustomAction: " + ca);
};

eplProductGallery.prototype.createNextButton = function(){
    var that = this;
    var container = this.createBox("10%", "100%", "center", "center");
    var btn = this.createBox("100%", "20%", "center", "center");
    btn.style["cursor"] = "pointer";
    btn.style["border"] = "1px solid gray";
    btn.style["font-size"] = "3vw";
    btn.innerHTML = ">";
    btn.onclick = function(){that.nextProduct();};
    container.appendChild(btn);
    this.container.appendChild(container);
};

eplProductGallery.prototype.createProductSection = function(){
    var that = this;
    var containerProductos = this.createBox("80%", "100%", "center", "center");
    this.container.appendChild(containerProductos);
    if(this.cols === 1){
        var a = this.createBox("100%", "100%", "center", "center");
        a.id = "producto0";
        a.style["flex-direction"] = "row";
        a.style["margin"] = "4vw";
        a.style["cursor"] = "pointer";
        containerProductos.appendChild(a);
        
        var imgContainer = this.createBox("50%", "100%", "center", "center");
        var imgProducto = document.createElement("img");
        imgProducto.id = "productoImagen0";
        imgProducto.style["width"] = "100%";
        imgProducto.style["height"] = "100%";
        imgProducto.style["border"] = "2px solid green";
        this.getNextIndice();
        imgProducto.src = this.productos[this.indiceProducto].url;
        imgContainer.appendChild(imgProducto);
        a.appendChild(imgContainer);
        a.setAttribute("data-click", this.productos[this.indiceProducto].clickTag);
        a.setAttribute("data-ca", this.productos[this.indiceProducto].CustomAction);
        a.onclick = function(){
            var producto = that.productos[that.indiceProducto].titulo;
            var ct = parseInt(this.getAttribute("data-click"));
            var ca = parseInt(this.getAttribute("data-ca"));
            that.comprarProducto(producto, ct, ca);
        };
        var textContainer = this.createBox("50%", "60%", "center", "center");
        var divisor = document.createElement("hr");
        divisor.style["width"] = "70%";
        var descContainer = this.createBox("100%", "40%", "center", "center");
        descContainer.id = "productoDesc0";
        var precioContainer = this.createBox("100%", "60%", "center", "center");
        precioContainer.id = "productoPrecio0";
        
        textContainer.style["flex-direction"] = "column";
        descContainer.style["font-size"] = "4vw";
        descContainer.style["text-align"] = "center";
        descContainer.style["color"] = this.options.ColorDescripcion;
            
        precioContainer.style["font-size"] = "6vw";
        precioContainer.style["font-weight"] = "bold";
        precioContainer.style["text-align"] = "center";
        precioContainer.style["color"] = this.options.ColorPrecio;
            
        descContainer.innerHTML = this.productos[this.indiceProducto].titulo;
        precioContainer.innerHTML = this.productos[this.indiceProducto].precio;
            
        textContainer.appendChild(descContainer);
        textContainer.appendChild(divisor);
        textContainer.appendChild(precioContainer);
            
        a.appendChild(textContainer);
        
    }else{
        for(var i = 0; i < 3; i++){
            var a = this.createBox("26.66%", "100%", "center", "center");
            a.id = "producto" + i;
            a.style["flex-direction"] = "column";
            a.style["margin"] = "auto";
            a.style["cursor"] = "pointer";
            
            containerProductos.appendChild(a);
            var imgContainer = this.createBox("100%", "60%", "center", "center");
            var imgProducto = document.createElement("img");
            imgProducto.id = "productoImagen" + i;
            imgProducto.style["width"] = "100%";
            imgProducto.style["height"] = "100%";
            imgProducto.style["border"] = "2px solid green";
            this.getNextIndice();
            imgProducto.src = this.productos[this.indiceProducto].url;
            imgContainer.appendChild(imgProducto);
            a.appendChild(imgContainer);
            a.setAttribute("data-click", this.productos[this.indiceProducto].clickTag);
            a.setAttribute("data-ca", this.productos[this.indiceProducto].CustomAction);
            a.onclick = function(){
                var producto = that.productos[that.indiceProducto].titulo;
                var ct = parseInt(this.getAttribute("data-click"));
                var ca = parseInt(this.getAttribute("data-ca"));
                that.comprarProducto(producto, ct, ca);
            };
            
            var textContainer = this.createBox("100%", "40%", "center", "center");
            var divisor = document.createElement("hr");
            //divisor.style["border-top"] = "1px solid grey !important";
            divisor.style["width"] = "100%";
            var descContainer = this.createBox("100%", "60%", "center", "center");
            descContainer.id = "productoDesc" + i;
            var precioContainer = this.createBox("100%", "40%", "center", "center");
            precioContainer.id = "productoPrecio" + i;
            
            textContainer.style["flex-direction"] = "column";
            
            descContainer.style["font-size"] = "3.5vw";
            descContainer.style["color"] = this.options.ColorDescripcion;
            
            precioContainer.style["font-size"] = "5vw";
            precioContainer.style["font-weight"] = "bold";
            precioContainer.style["color"] = this.options.ColorPrecio;
            
            descContainer.innerHTML = this.productos[this.indiceProducto].titulo;
            precioContainer.innerHTML = this.productos[this.indiceProducto].precio;
            
            textContainer.appendChild(descContainer);
            textContainer.appendChild(divisor);
            textContainer.appendChild(precioContainer);
            
            a.appendChild(textContainer);
        }
    }
};

eplProductGallery.prototype.nextProduct = function(){
    var that = this;
    function actualizarProducto(indice){
        document.getElementById("producto" + indice).setAttribute("data-click", that.productos[that.indiceProducto].clickTag);
        document.getElementById("producto" + indice).setAttribute("data-ca", that.productos[that.indiceProducto].CustomAction);
        document.getElementById("productoImagen" + indice).src = that.productos[that.indiceProducto].url;
        document.getElementById("productoDesc" + indice).innerHTML = that.productos[that.indiceProducto].titulo;
        document.getElementById("productoPrecio" + indice).innerHTML = that.productos[that.indiceProducto].precio;
    }
    if(this.cols === 1){
        that.getNextIndice();
        actualizarProducto(0);
    }else{
        that.getNextIndice();
        actualizarProducto(2);
        that.getPrevIndice();
        actualizarProducto(1);
        that.getPrevIndice();
        actualizarProducto(0);
        
        that.getNextIndice();
        that.getNextIndice();
    }
};

eplProductGallery.prototype.prevProduct = function(){
    var that = this;
    function actualizarProducto(indice){
        document.getElementById("producto" + indice).setAttribute("data-click", that.productos[that.indiceProducto].clickTag);
        document.getElementById("producto" + indice).setAttribute("data-ca", that.productos[that.indiceProducto].CustomAction);
        document.getElementById("productoImagen" + indice).src = that.productos[that.indiceProducto].url;
        document.getElementById("productoDesc" + indice).innerHTML = that.productos[that.indiceProducto].titulo;
        document.getElementById("productoPrecio" + indice).innerHTML = that.productos[that.indiceProducto].precio;
    }
    if(this.cols === 1){
        that.getPrevIndice();
        actualizarProducto(0);
    }else{
        that.getPrevIndice();
        that.getPrevIndice();
        
        that.getPrevIndice();
        actualizarProducto(0);
        that.getNextIndice();
        actualizarProducto(1);
        that.getNextIndice();
        actualizarProducto(2);
    }
};

eplProductGallery.prototype.init = function(){
    this.createPrevButton();
    this.createProductSection();
    this.createNextButton();
    console.log("Columnas: " + this.cols);
};